Package org.kapott.hbci.manager

# Interface HBCIKernel

All Known Implementing Classes:
  `HBCIKernelImpl`

public interface HBCIKernel
HBCI-Kernel für eine bestimmte HBCI-Version. Objekte dieser Klasse werden intern für die Nachrichtenerzeugung und -analyse verwendet.

## Method Summary

Modifier and Type
Method
Description
`Hashtable<String,List<String>>`
`getAllLowlevelJobs()`
Gibt die Namen und Versionen aller von HBCI4Java für die aktuelle HBCI-Version (siehe `getHBCIVersion()`) unterstützten Lowlevel-Geschäftsvorfälle zurück.
`String`
`getHBCIVersion()`
Gibt die HBCI-Versionsnummer zurück, für die dieses Kernel-Objekt Nachrichten erzeugen und analysieren kann.
`List`
`getLowlevelJobParameterNames(String gvname, String version)`
Gibt alle für einen bestimmten Lowlevel-Job möglichen Job-Parameter-Namen zurück.
`List`
`getLowlevelJobRestrictionNames(String gvname, String version)`
Gibt für einen bestimmten Lowlevel-Job die Namen aller möglichen Job-Restriction-Parameter zurück (siehe auch `HBCIJob.getJobRestrictions()` und `HBCIHandler.getLowlevelJobRestrictions(String)`).
`List`
`getLowlevelJobResultNames(String gvname, String version)`
Gibt für einen bestimmten Lowlevel-Job die Namen aller möglichen Lowlevel-Result-Properties zurück (siehe `HBCIJobResult.getResultData()`).

## Method Details

### getHBCIVersion

String getHBCIVersion()
Gibt die HBCI-Versionsnummer zurück, für die dieses Kernel-Objekt Nachrichten erzeugen und analysieren kann.

Returns:
  HBCI-Versionsnummer

### getAllLowlevelJobs

Hashtable<String,List<String>> getAllLowlevelJobs()

Gibt die Namen und Versionen aller von HBCI4Java für die aktuelle HBCI-Version (siehe `getHBCIVersion()`) unterstützten Lowlevel-Geschäftsvorfälle zurück. Es ist zu beachten, dass ein konkreter HBCI-Zugang i.d.R. nicht alle in dieser Liste aufgeführten Geschäftsvorfälle auch tatsächlich anbietet (siehe dafür `HBCIHandler.getSupportedLowlevelJobs()`).

Die zurückgegebene Hashtable enthält als Key jeweils einen String mit dem Bezeichner eines Lowlevel-Jobs, welcher für die Erzeugung eines Lowlevel-Jobs mit `HBCIHandler.newLowlevelJob(String)` verwendet werden kann. Der dazugehörige Wert ist ein List-Objekt (bestehend aus Strings), welches alle GV-Versionsnummern enthält, die von HBCI4Java für diesen GV unterstützt werden.

Returns:
  Hashtable aller Lowlevel-Jobs, die prinzipiell vom aktuellen Handler-Objekt unterstützt werden.

### getLowlevelJobParameterNames

List getLowlevelJobParameterNames(String gvname, String version)

Gibt alle für einen bestimmten Lowlevel-Job möglichen Job-Parameter-Namen zurück. Der übergebene Job-Name ist einer der von HBCI4Java unterstützten Jobnamen, die Versionsnummer muss eine der für diesen GV unterstützten Versionsnummern sein (siehe `getAllLowlevelJobs()`). Als Ergebnis erhält man eine Liste aller Parameter-Namen, die für einen Lowlevel-Job (siehe `HBCIHandler.newLowlevelJob(String)`) gesetzt werden können (siehe `HBCIJob.setParam(String, String)`).

Aus der Liste der möglichen Parameternamen ist nicht ersichtlich, welche Parameter zwingend und welche optional sind, bzw. wie oft ein Parameter mindestens oder höchstens auftreten darf. Für diese Art der Informationen stehen zur Zeit noch keine Methoden bereit.

Siehe dazu auch `HBCIHandler.getLowlevelJobParameterNames(String)`.

Parameters:
  `gvname` - Name des Lowlevel-Jobs
  `version` - Version des Lowlevel-jobs
Returns:
  Liste aller Job-Parameter, die beim Erzeugen des angegebenen Lowlevel-Jobs gesetzt werden können

### getLowlevelJobResultNames

List getLowlevelJobResultNames(String gvname, String version)

Gibt für einen bestimmten Lowlevel-Job die Namen aller möglichen Lowlevel-Result-Properties zurück (siehe `HBCIJobResult.getResultData()`). Der übergebene Job-Name ist einer der von HBCI4Java unterstützten Jobnamen, die Versionsnummer muss eine der für diesen GV unterstützten Versionsnummern sein (siehe `getAllLowlevelJobs()`). Als Ergebnis erhält man eine Liste aller Property-Namen, die in den Lowlevel-Ergebnisdaten eines Jobs auftreten können.

Aus der resultierenden Liste ist nicht ersichtlich, welche Properties immer zurückgeben werden und welche optional sind, bzw. wie oft ein bestimmter Wert mindestens oder höchstens auftreten kann. Für diese Art der Informationen stehen zur Zeit noch keine Methoden bereit.

Siehe dazu auch `HBCIHandler.getLowlevelJobResultNames(String)`.

Parameters:
  `gvname` - Name des Lowlevel-Jobs
  `version` - Version des Lowlevel-jobs
Returns:
  Liste aller Property-Namen, die in den Lowlevel-Antwortdaten eines Jobs auftreten können

### getLowlevelJobRestrictionNames

List getLowlevelJobRestrictionNames(String gvname, String version)

Gibt für einen bestimmten Lowlevel-Job die Namen aller möglichen Job-Restriction-Parameter zurück (siehe auch `HBCIJob.getJobRestrictions()` und `HBCIHandler.getLowlevelJobRestrictions(String)`). Der übergebene Job-Name ist einer der von HBCI4Java unterstützten Jobnamen, die Versionsnummer muss eine der für diesen GV unterstützten Versionsnummern sein (siehe `getAllLowlevelJobs()`). Als Ergebnis erhält man eine Liste aller Property-Namen, die in den Job-Restrictions-Daten eines Jobs auftreten können.

Parameters:
  `gvname` - Name des Lowlevel-Jobs
  `version` - Version des Lowlevel-jobs
Returns:
  Liste aller Property-Namen, die in den Job-Restriction-Daten eines Jobs auftreten können